package cn.superdesk.uniorder.dao.entity.sys.role;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class SysRoleExtDataSampleExample {
    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    protected String orderByClause;

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    protected boolean distinct;

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public SysRoleExtDataSampleExample() {
        oredCriteria = new ArrayList<>();
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andServiceNoIsNull() {
            addCriterion("service_no is null");
            return (Criteria) this;
        }

        public Criteria andServiceNoIsNotNull() {
            addCriterion("service_no is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNoEqualTo(String value) {
            addCriterion("service_no =", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotEqualTo(String value) {
            addCriterion("service_no <>", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoGreaterThan(String value) {
            addCriterion("service_no >", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoGreaterThanOrEqualTo(String value) {
            addCriterion("service_no >=", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLessThan(String value) {
            addCriterion("service_no <", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLessThanOrEqualTo(String value) {
            addCriterion("service_no <=", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLike(String value) {
            addCriterion("service_no like", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotLike(String value) {
            addCriterion("service_no not like", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoIn(List<String> values) {
            addCriterion("service_no in", values, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotIn(List<String> values) {
            addCriterion("service_no not in", values, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoBetween(String value1, String value2) {
            addCriterion("service_no between", value1, value2, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotBetween(String value1, String value2) {
            addCriterion("service_no not between", value1, value2, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNameIsNull() {
            addCriterion("service_name is null");
            return (Criteria) this;
        }

        public Criteria andServiceNameIsNotNull() {
            addCriterion("service_name is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNameEqualTo(String value) {
            addCriterion("service_name =", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotEqualTo(String value) {
            addCriterion("service_name <>", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameGreaterThan(String value) {
            addCriterion("service_name >", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameGreaterThanOrEqualTo(String value) {
            addCriterion("service_name >=", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLessThan(String value) {
            addCriterion("service_name <", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLessThanOrEqualTo(String value) {
            addCriterion("service_name <=", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLike(String value) {
            addCriterion("service_name like", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotLike(String value) {
            addCriterion("service_name not like", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameIn(List<String> values) {
            addCriterion("service_name in", values, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotIn(List<String> values) {
            addCriterion("service_name not in", values, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameBetween(String value1, String value2) {
            addCriterion("service_name between", value1, value2, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotBetween(String value1, String value2) {
            addCriterion("service_name not between", value1, value2, "serviceName");
            return (Criteria) this;
        }

        public Criteria andSourceFromIsNull() {
            addCriterion("source_from is null");
            return (Criteria) this;
        }

        public Criteria andSourceFromIsNotNull() {
            addCriterion("source_from is not null");
            return (Criteria) this;
        }

        public Criteria andSourceFromEqualTo(String value) {
            addCriterion("source_from =", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotEqualTo(String value) {
            addCriterion("source_from <>", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromGreaterThan(String value) {
            addCriterion("source_from >", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromGreaterThanOrEqualTo(String value) {
            addCriterion("source_from >=", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromLessThan(String value) {
            addCriterion("source_from <", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromLessThanOrEqualTo(String value) {
            addCriterion("source_from <=", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromLike(String value) {
            addCriterion("source_from like", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotLike(String value) {
            addCriterion("source_from not like", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromIn(List<String> values) {
            addCriterion("source_from in", values, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotIn(List<String> values) {
            addCriterion("source_from not in", values, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromBetween(String value1, String value2) {
            addCriterion("source_from between", value1, value2, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotBetween(String value1, String value2) {
            addCriterion("source_from not between", value1, value2, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdIsNull() {
            addCriterion("source_from_quote_id is null");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdIsNotNull() {
            addCriterion("source_from_quote_id is not null");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdEqualTo(Long value) {
            addCriterion("source_from_quote_id =", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdNotEqualTo(Long value) {
            addCriterion("source_from_quote_id <>", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdGreaterThan(Long value) {
            addCriterion("source_from_quote_id >", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdGreaterThanOrEqualTo(Long value) {
            addCriterion("source_from_quote_id >=", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdLessThan(Long value) {
            addCriterion("source_from_quote_id <", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdLessThanOrEqualTo(Long value) {
            addCriterion("source_from_quote_id <=", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdIn(List<Long> values) {
            addCriterion("source_from_quote_id in", values, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdNotIn(List<Long> values) {
            addCriterion("source_from_quote_id not in", values, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdBetween(Long value1, Long value2) {
            addCriterion("source_from_quote_id between", value1, value2, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdNotBetween(Long value1, Long value2) {
            addCriterion("source_from_quote_id not between", value1, value2, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdIsNull() {
            addCriterion("source_from_quote_parent_id is null");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdIsNotNull() {
            addCriterion("source_from_quote_parent_id is not null");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdEqualTo(Long value) {
            addCriterion("source_from_quote_parent_id =", value, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdNotEqualTo(Long value) {
            addCriterion("source_from_quote_parent_id <>", value, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdGreaterThan(Long value) {
            addCriterion("source_from_quote_parent_id >", value, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("source_from_quote_parent_id >=", value, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdLessThan(Long value) {
            addCriterion("source_from_quote_parent_id <", value, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdLessThanOrEqualTo(Long value) {
            addCriterion("source_from_quote_parent_id <=", value, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdIn(List<Long> values) {
            addCriterion("source_from_quote_parent_id in", values, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdNotIn(List<Long> values) {
            addCriterion("source_from_quote_parent_id not in", values, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdBetween(Long value1, Long value2) {
            addCriterion("source_from_quote_parent_id between", value1, value2, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteParentIdNotBetween(Long value1, Long value2) {
            addCriterion("source_from_quote_parent_id not between", value1, value2, "sourceFromQuoteParentId");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeIsNull() {
            addCriterion("permit_start_time is null");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeIsNotNull() {
            addCriterion("permit_start_time is not null");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeEqualTo(Date value) {
            addCriterion("permit_start_time =", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeNotEqualTo(Date value) {
            addCriterion("permit_start_time <>", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeGreaterThan(Date value) {
            addCriterion("permit_start_time >", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("permit_start_time >=", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeLessThan(Date value) {
            addCriterion("permit_start_time <", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeLessThanOrEqualTo(Date value) {
            addCriterion("permit_start_time <=", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeIn(List<Date> values) {
            addCriterion("permit_start_time in", values, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeNotIn(List<Date> values) {
            addCriterion("permit_start_time not in", values, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeBetween(Date value1, Date value2) {
            addCriterion("permit_start_time between", value1, value2, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeNotBetween(Date value1, Date value2) {
            addCriterion("permit_start_time not between", value1, value2, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeIsNull() {
            addCriterion("permit_end_time is null");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeIsNotNull() {
            addCriterion("permit_end_time is not null");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeEqualTo(Date value) {
            addCriterion("permit_end_time =", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeNotEqualTo(Date value) {
            addCriterion("permit_end_time <>", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeGreaterThan(Date value) {
            addCriterion("permit_end_time >", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("permit_end_time >=", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeLessThan(Date value) {
            addCriterion("permit_end_time <", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("permit_end_time <=", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeIn(List<Date> values) {
            addCriterion("permit_end_time in", values, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeNotIn(List<Date> values) {
            addCriterion("permit_end_time not in", values, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeBetween(Date value1, Date value2) {
            addCriterion("permit_end_time between", value1, value2, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("permit_end_time not between", value1, value2, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtIsNull() {
            addCriterion("is_bind_virt is null");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtIsNotNull() {
            addCriterion("is_bind_virt is not null");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtEqualTo(Integer value) {
            addCriterion("is_bind_virt =", value, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtNotEqualTo(Integer value) {
            addCriterion("is_bind_virt <>", value, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtGreaterThan(Integer value) {
            addCriterion("is_bind_virt >", value, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_bind_virt >=", value, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtLessThan(Integer value) {
            addCriterion("is_bind_virt <", value, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtLessThanOrEqualTo(Integer value) {
            addCriterion("is_bind_virt <=", value, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtIn(List<Integer> values) {
            addCriterion("is_bind_virt in", values, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtNotIn(List<Integer> values) {
            addCriterion("is_bind_virt not in", values, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtBetween(Integer value1, Integer value2) {
            addCriterion("is_bind_virt between", value1, value2, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andIsBindVirtNotBetween(Integer value1, Integer value2) {
            addCriterion("is_bind_virt not between", value1, value2, "isBindVirt");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdIsNull() {
            addCriterion("sys_org_id is null");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdIsNotNull() {
            addCriterion("sys_org_id is not null");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdEqualTo(Long value) {
            addCriterion("sys_org_id =", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdNotEqualTo(Long value) {
            addCriterion("sys_org_id <>", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdGreaterThan(Long value) {
            addCriterion("sys_org_id >", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sys_org_id >=", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdLessThan(Long value) {
            addCriterion("sys_org_id <", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdLessThanOrEqualTo(Long value) {
            addCriterion("sys_org_id <=", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdIn(List<Long> values) {
            addCriterion("sys_org_id in", values, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdNotIn(List<Long> values) {
            addCriterion("sys_org_id not in", values, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdBetween(Long value1, Long value2) {
            addCriterion("sys_org_id between", value1, value2, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdNotBetween(Long value1, Long value2) {
            addCriterion("sys_org_id not between", value1, value2, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdIsNull() {
            addCriterion("out_org_id is null");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdIsNotNull() {
            addCriterion("out_org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdEqualTo(Long value) {
            addCriterion("out_org_id =", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdNotEqualTo(Long value) {
            addCriterion("out_org_id <>", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdGreaterThan(Long value) {
            addCriterion("out_org_id >", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdGreaterThanOrEqualTo(Long value) {
            addCriterion("out_org_id >=", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdLessThan(Long value) {
            addCriterion("out_org_id <", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdLessThanOrEqualTo(Long value) {
            addCriterion("out_org_id <=", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdIn(List<Long> values) {
            addCriterion("out_org_id in", values, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdNotIn(List<Long> values) {
            addCriterion("out_org_id not in", values, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdBetween(Long value1, Long value2) {
            addCriterion("out_org_id between", value1, value2, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdNotBetween(Long value1, Long value2) {
            addCriterion("out_org_id not between", value1, value2, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsIsNull() {
            addCriterion("sys_virt_ids is null");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsIsNotNull() {
            addCriterion("sys_virt_ids is not null");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsEqualTo(String value) {
            addCriterion("sys_virt_ids =", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsNotEqualTo(String value) {
            addCriterion("sys_virt_ids <>", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsGreaterThan(String value) {
            addCriterion("sys_virt_ids >", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsGreaterThanOrEqualTo(String value) {
            addCriterion("sys_virt_ids >=", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsLessThan(String value) {
            addCriterion("sys_virt_ids <", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsLessThanOrEqualTo(String value) {
            addCriterion("sys_virt_ids <=", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsLike(String value) {
            addCriterion("sys_virt_ids like", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsNotLike(String value) {
            addCriterion("sys_virt_ids not like", value, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsIn(List<String> values) {
            addCriterion("sys_virt_ids in", values, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsNotIn(List<String> values) {
            addCriterion("sys_virt_ids not in", values, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsBetween(String value1, String value2) {
            addCriterion("sys_virt_ids between", value1, value2, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdsNotBetween(String value1, String value2) {
            addCriterion("sys_virt_ids not between", value1, value2, "sysVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsIsNull() {
            addCriterion("out_virt_ids is null");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsIsNotNull() {
            addCriterion("out_virt_ids is not null");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsEqualTo(String value) {
            addCriterion("out_virt_ids =", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsNotEqualTo(String value) {
            addCriterion("out_virt_ids <>", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsGreaterThan(String value) {
            addCriterion("out_virt_ids >", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsGreaterThanOrEqualTo(String value) {
            addCriterion("out_virt_ids >=", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsLessThan(String value) {
            addCriterion("out_virt_ids <", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsLessThanOrEqualTo(String value) {
            addCriterion("out_virt_ids <=", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsLike(String value) {
            addCriterion("out_virt_ids like", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsNotLike(String value) {
            addCriterion("out_virt_ids not like", value, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsIn(List<String> values) {
            addCriterion("out_virt_ids in", values, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsNotIn(List<String> values) {
            addCriterion("out_virt_ids not in", values, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsBetween(String value1, String value2) {
            addCriterion("out_virt_ids between", value1, value2, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdsNotBetween(String value1, String value2) {
            addCriterion("out_virt_ids not between", value1, value2, "outVirtIds");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNull() {
            addCriterion("deleted is null");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNotNull() {
            addCriterion("deleted is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedEqualTo(Integer value) {
            addCriterion("deleted =", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotEqualTo(Integer value) {
            addCriterion("deleted <>", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThan(Integer value) {
            addCriterion("deleted >", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThanOrEqualTo(Integer value) {
            addCriterion("deleted >=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThan(Integer value) {
            addCriterion("deleted <", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThanOrEqualTo(Integer value) {
            addCriterion("deleted <=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedIn(List<Integer> values) {
            addCriterion("deleted in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotIn(List<Integer> values) {
            addCriterion("deleted not in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedBetween(Integer value1, Integer value2) {
            addCriterion("deleted between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotBetween(Integer value1, Integer value2) {
            addCriterion("deleted not between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * do_not_delete_during_merge Mon Sep 21 15:51:22 CST 2020
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
     *
     * table sys_role_ext_data_sample
     *
     * Mon Sep 21 15:51:22 CST 2020
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}